"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var autoBind = require("auto-bind");
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var graphql_codegen_flow_1 = require("graphql-codegen-flow");
var FlowResolversVisitor = /** @class */ (function (_super) {
    __extends(FlowResolversVisitor, _super);
    function FlowResolversVisitor(pluginConfig, schema) {
        var _this = _super.call(this, pluginConfig, null, schema) || this;
        autoBind(_this);
        _this.setVariablesTransformer(new graphql_codegen_flow_1.FlowOperationVariablesToObject(_this.config.scalars, _this.convertName));
        return _this;
    }
    FlowResolversVisitor.prototype.formatRootResolver = function (schemaTypeName, resolverType) {
        return schemaTypeName + "?: " + resolverType + "<>,";
    };
    FlowResolversVisitor.prototype.buildMapperImport = function (source, types) {
        return "import { " + types.map(function (t) { return "type " + t; }).join(', ') + " } from '" + source + "';";
    };
    FlowResolversVisitor.prototype.ListType = function (node) {
        return "?" + _super.prototype.ListType.call(this, node);
    };
    FlowResolversVisitor.prototype.NamedType = function (node) {
        return "?" + _super.prototype.NamedType.call(this, node);
    };
    FlowResolversVisitor.prototype.NonNullType = function (node) {
        var baseValue = _super.prototype.NonNullType.call(this, node);
        if (baseValue.charAt(0) === '?') {
            return baseValue.substr(1);
        }
        return baseValue;
    };
    return FlowResolversVisitor;
}(graphql_codegen_visitor_plugin_common_1.BaseResolversVisitor));
exports.FlowResolversVisitor = FlowResolversVisitor;
//# sourceMappingURL=visitor.js.map